"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _Compiler_instances, _Compiler_instance, _Compiler_done, _Compiler_processAssets, _Compiler_newCompilation;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Compiler = void 0;
const binding = __importStar(require("@rspack/binding"));
const Logger_1 = require("./logging/Logger");
const watch_1 = require("./config/watch");
const tapable = __importStar(require("tapable"));
const tapable_1 = require("tapable");
const util_1 = __importDefault(require("util"));
const fs_1 = __importDefault(require("fs"));
const neo_async_1 = __importDefault(require("neo-async"));
const path_1 = __importDefault(require("path"));
const stats_1 = require("./stats");
const compilation_1 = require("./compilation");
class EntryPlugin {
    apply() { }
}
class HotModuleReplacementPlugin {
    apply() { }
}
class Compiler {
    constructor(context, options) {
        _Compiler_instances.add(this);
        _Compiler_instance.set(this, void 0);
        this.options = options;
        // to workaround some plugin access webpack, we may change dev-server to avoid this hack in the future
        this.webpack = {
            EntryPlugin,
            HotModuleReplacementPlugin // modernjs/server will auto inject this this plugin not set
        };
        // @ts-ignored
        __classPrivateFieldSet(this, _Compiler_instance, new binding.Rspack(this.options, {
            doneCallback: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_done).bind(this),
            processAssetsCallback: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_processAssets).bind(this)
        }), "f");
        this.hooks = {
            initialize: new tapable_1.SyncHook([]),
            done: new tapable.AsyncSeriesHook(["stats"]),
            afterDone: new tapable.SyncHook(["stats"]),
            beforeRun: new tapable.AsyncSeriesHook(["compiler"]),
            run: new tapable.AsyncSeriesHook(["compiler"]),
            thisCompilation: new tapable.SyncHook([
                "compilation",
                "params"
            ]),
            compilation: new tapable.SyncHook(["compilation"]),
            invalid: new tapable_1.SyncHook(["filename", "changeTime"]),
            compile: new tapable_1.SyncHook(["params"]),
            infrastructureLog: new tapable_1.SyncBailHook(["origin", "type", "args"]),
            failed: new tapable_1.SyncHook(["error"])
        };
    }
    getInfrastructureLogger(name) {
        if (!name) {
            throw new TypeError("Compiler.getInfrastructureLogger(name) called without a name");
        }
        return new Logger_1.Logger((type, args) => {
            if (typeof name === "function") {
                name = name();
                if (!name) {
                    throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                }
            }
            else {
                if (this.hooks.infrastructureLog.call(name, type, args) === undefined) {
                    if (this.infrastructureLogger !== undefined) {
                        this.infrastructureLogger(name, type, args);
                    }
                }
            }
        }, childName => {
            if (typeof name === "function") {
                if (typeof childName === "function") {
                    return this.getInfrastructureLogger(_ => {
                        if (typeof name === "function") {
                            name = name();
                            if (!name) {
                                throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                            }
                        }
                        if (typeof childName === "function") {
                            childName = childName();
                            if (!childName) {
                                throw new TypeError("Logger.getChildLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
                else {
                    return this.getInfrastructureLogger(() => {
                        if (typeof name === "function") {
                            name = name();
                            if (!name) {
                                throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
            }
            else {
                if (typeof childName === "function") {
                    return this.getInfrastructureLogger(() => {
                        if (typeof childName === "function") {
                            childName = childName();
                            if (!childName) {
                                throw new TypeError("Logger.getChildLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
                else {
                    return this.getInfrastructureLogger(`${name}/${childName}`);
                }
            }
        });
    }
    run(callback) {
        const doRun = () => {
            const finalCallback = (err, stats) => {
                if (err) {
                    this.hooks.failed.call(err);
                }
                if (callback) {
                    callback(err, stats);
                }
                this.hooks.afterDone.call(stats);
            };
            this.hooks.beforeRun.callAsync(this, err => {
                if (err) {
                    return finalCallback(err);
                }
                this.hooks.run.callAsync(this, err => {
                    if (err) {
                        return finalCallback(err);
                    }
                    this.build((err, raw_stats) => {
                        if (err) {
                            return finalCallback(err);
                        }
                        const stats = new stats_1.Stats(this.compilation, raw_stats);
                        this.hooks.done.callAsync(stats, err => {
                            if (err) {
                                return finalCallback(err);
                            }
                            else {
                                return finalCallback(null, stats);
                            }
                        });
                    });
                });
            });
        };
        doRun();
    }
    build(cb) {
        const compilation = __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_newCompilation).call(this);
        const build_cb = util_1.default.callbackify(__classPrivateFieldGet(this, _Compiler_instance, "f").build.bind(__classPrivateFieldGet(this, _Compiler_instance, "f")));
        build_cb((err, stats) => {
            if (err) {
                cb(err);
            }
            else {
                cb(null, stats);
            }
        });
    }
    rebuild(changedFiles, cb) {
        const rebuild_cb = util_1.default.callbackify(__classPrivateFieldGet(this, _Compiler_instance, "f").rebuild.bind(__classPrivateFieldGet(this, _Compiler_instance, "f"), changedFiles, []));
        rebuild_cb((err, stats) => {
            if (err) {
                cb(err);
            }
            else {
                cb(null, stats);
            }
        });
    }
    async watch(watchOptions) {
        const options = (0, watch_1.resolveWatchOption)(watchOptions);
        const watcher = (await Promise.resolve().then(() => __importStar(require("chokidar")))).default.watch(this.options.context, {
            ignoreInitial: true,
            ...options
        });
        let stats = await util_1.default.promisify(this.build.bind(this))();
        // TODO: should use aggregated
        watcher.on("change", async (path) => {
            // TODO: only build because we lack the snapshot info of file.
            // TODO: it means there a lot of things to do....
            const begin = Date.now();
            console.log("hit change and start to build");
            const diffStats = await util_1.default.promisify(this.rebuild.bind(this))([path]);
            console.log(`build success, time cost ${(Date.now() - begin) / 1000}ms`);
        });
        return {
            async close() {
                await watcher.close();
            }
        };
    }
    purgeInputFileSystem() {
        if (this.inputFileSystem && this.inputFileSystem.purge) {
            this.inputFileSystem.purge();
        }
    }
    /**
     * @todo
     */
    close(callback) {
        callback();
    }
    emitAssets(compilation, callback) {
        const outputPath = compilation.getPath(this.outputPath, {});
        fs_1.default.mkdirSync(outputPath, { recursive: true });
        const assets = compilation.getAssets();
        compilation.assets = { ...compilation.assets };
        neo_async_1.default.forEachLimit(assets, 15, ({ name: file, source, info }, callback) => {
            let targetFile = file;
            const absPath = path_1.default.resolve(outputPath, targetFile);
            const getContent = () => {
                if (typeof source.buffer === "function") {
                    return source.buffer();
                }
                else {
                    const bufferOrString = source.source();
                    if (Buffer.isBuffer(bufferOrString)) {
                        return bufferOrString;
                    }
                    else {
                        return Buffer.from(bufferOrString, "utf-8");
                    }
                }
            };
            const doWrite = content => {
                this.outputFileSystem.writeFile(absPath, content, callback);
            };
            let content = getContent();
            doWrite(content);
        });
    }
}
exports.Compiler = Compiler;
_Compiler_instance = new WeakMap(), _Compiler_instances = new WeakSet(), _Compiler_done = function _Compiler_done(statsJson) { }, _Compiler_processAssets = function _Compiler_processAssets(value, emitAsset) {
    return this.compilation.processAssets(value, emitAsset);
}, _Compiler_newCompilation = function _Compiler_newCompilation() {
    const compilation = new compilation_1.Compilation(this.options);
    this.compilation = compilation;
    this.hooks.compilation.call(compilation);
    return compilation;
};
//# sourceMappingURL=compiler.js.map