"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDevOptions = exports.getAdditionDevEntry = void 0;
const node_path_1 = __importDefault(require("node:path"));
const watch_1 = require("./watch");
function getAdditionDevEntry() {
    const devClientEntryPath = require.resolve("@rspack/dev-client");
    return {
        "rspack-dev-client": devClientEntryPath
    };
}
exports.getAdditionDevEntry = getAdditionDevEntry;
function resolveDevOptions(devConfig = {}, context) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    const port = (_a = devConfig.port) !== null && _a !== void 0 ? _a : 8080;
    const open = true;
    const hmr = false;
    // --- static
    const directory = (_c = (_b = devConfig.static) === null || _b === void 0 ? void 0 : _b.directory) !== null && _c !== void 0 ? _c : node_path_1.default.resolve(context.context, "dist");
    let watch = {};
    if (((_d = devConfig.static) === null || _d === void 0 ? void 0 : _d.watch) === false) {
        watch = false;
    }
    else if (((_e = devConfig.static) === null || _e === void 0 ? void 0 : _e.watch) === true) {
        watch = (0, watch_1.resolveWatchOption)({});
    }
    else if ((_f = devConfig.static) === null || _f === void 0 ? void 0 : _f.watch) {
        watch = (_g = devConfig.static) === null || _g === void 0 ? void 0 : _g.watch;
    }
    // ---
    const devMiddleware = (_h = devConfig.devMiddleware) !== null && _h !== void 0 ? _h : {};
    const liveReload = (_j = devConfig.liveReload) !== null && _j !== void 0 ? _j : true;
    let webSocketServer = {};
    if (devConfig.webSocketServer === false) {
        webSocketServer = false;
    }
    else if (devConfig.webSocketServer === true) {
        webSocketServer = {};
    }
    else if (devConfig.webSocketServer) {
        webSocketServer = devConfig.webSocketServer;
    }
    return {
        port,
        static: {
            directory,
            watch
        },
        devMiddleware,
        open,
        hmr,
        liveReload,
        webSocketServer
    };
}
exports.resolveDevOptions = resolveDevOptions;
//# sourceMappingURL=devServer.js.map