"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveEntryOptions = exports.resolveEntry = void 0;
const devServer_1 = require("./devServer");
const utils_1 = require("../utils");
const path_1 = __importDefault(require("path"));
function resolveEntry(entry = {}, context) {
    if (!context.dev) {
        return entry;
    }
    else {
        return {
            ...entry,
            ...(0, devServer_1.getAdditionDevEntry)()
        };
    }
}
exports.resolveEntry = resolveEntry;
function resolveEntryOptions(entry, options) {
    if (typeof entry === "string") {
        entry = {
            main: entry
        };
    }
    return {
        ...(0, utils_1.mapValues)(entry, item => path_1.default.resolve(options.context, item)),
        ...(options.dev ? (0, devServer_1.getAdditionDevEntry)() : {})
    };
}
exports.resolveEntryOptions = resolveEntryOptions;
//# sourceMappingURL=entry.js.map