"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeEnvironmentPlugin = void 0;
const createConsoleLogger_1 = __importDefault(require("../logging/createConsoleLogger"));
const nodeConsole_1 = __importDefault(require("./nodeConsole"));
const NodeWatchFileSystem_1 = require("./NodeWatchFileSystem");
class NodeEnvironmentPlugin {
    constructor(options) {
        this.options = options;
        this.options = options;
    }
    apply(compiler) {
        const { infrastructureLogging } = this.options;
        compiler.infrastructureLogger = (0, createConsoleLogger_1.default)({
            level: infrastructureLogging.level || "info",
            debug: infrastructureLogging.debug || false,
            console: infrastructureLogging.console ||
                (0, nodeConsole_1.default)({
                    colors: infrastructureLogging.colors,
                    appendOnly: infrastructureLogging.appendOnly,
                    stream: infrastructureLogging.stream
                })
        });
        compiler.watchFileSystem = new NodeWatchFileSystem_1.NodeWatchFileSystem(compiler.inputFileSystem);
    }
}
exports.NodeEnvironmentPlugin = NodeEnvironmentPlugin;
//# sourceMappingURL=NodeEnvironmentPlugin.js.map